/* qd.p quick dictionary chadb 08/01/97 */

{qd.i NEW}

PAUSE 0.
TERM=TERM.                                         /* required sometimes */
PAUSE 0.

DEF VAR m$ AS CHAR NO-UNDO INIT "Arrows, Pg-Up, Pg-Down, Home, End active".

DEF VAR j AS INT NO-UNDO.
DEF VAR ans        AS LOGICAL          NO-UNDO.
DEF VAR trid       AS RECID            NO-UNDO.

/* Programmer notes:

* Selecting File mode reopens the query with far fewer records and
assists in speedy navigation.  Jump mode is generally much slower
since all records are being processed.
* This dictionary browse is best used when you run it on an open terminal
session and leave it up all day, rather than re-running it every time it is
needed.
* There are three overlay programs: qd1.p, qd2.p and qd4.p.  Every
program can be precompiled in '.r' files although it is not required. 

Create '.r' files as follows:

compile qd.p save.
create alias xx for database your_progress_database.
compile qd1.p save.
compile qd2.p save.
compile qd4.p save.

-- Chad Brackmann, 08/12/97

*/

STATUS DEFAULT "Loading Schemas...".

RUN get-schema.ip IN THIS-PROCEDURE.                   /* INTERNAL PROCEDURE */

HIDE MESSAGE NO-PAUSE.

STATUS DEFAULT.

ON HELP, F2 ANYWHERE
DO:
  /* OVERRIDE APPLHELP */
  RUN show-help.ip IN THIS-PROCEDURE.
END.

ON F4, END-ERROR ANYWHERE
DO:
  RETURN NO-APPLY.
END.
  
DEF QUERY qry FOR ww CACHE 10000 /* SCROLLING */ .
DEF BUTTON button-File  LABEL "&File".
DEF BUTTON button-Jump  LABEL "&Jump".
DEF BUTTON button-Order LABEL "&Order".
DEF BUTTON button-Type  LABEL "&Type".
DEF BUTTON button-Index LABEL "&Index".
DEF BUTTON button-Zoom  LABEL "&Zoom".
DEF BUTTON button-Next  LABEL "&Nxt".
DEF BUTTON button-Prev  LABEL "&Prv".
DEF BUTTON button-ByFld LABEL "&ByFld".
DEF BUTTON button-Help  LABEL "&Help".
DEF BUTTON button-Quit  LABEL "&Quit".

DEF VAR v-file-name  AS CHAR FORMAT "x(14)" NO-UNDO.
DEF VAR v-jump-name  AS CHAR FORMAT "x(14)" NO-UNDO.
DEF VAR v-field-name AS CHAR FORMAT "x(14)" NO-UNDO.
DEF VAR v-type AS CHAR NO-UNDO FORMAT "x".
DEF VAR order-order AS LOGICAL INIT YES NO-UNDO.

DEF BROWSE brws QUERY qry
  DISP ww.w_file-name
  ww.w_field-name
  ww.w_label  FORMAT "x(9)"  
  ww.w_info
  ww.w_order FORMAT ">>>9" LABEL "Ordr"
  ww.w_db-name format "x(4)" label " DB "
  ww.w_format LABEL "Format" FORMAT "x(12)"
  WITH 16 DOWN TITLE " Dictionary Browse " .

FORM brws SKIP
  button-File button-Jump button-Order button-Type button-Index button-Zoom
  button-Next button-Prev button-ByFld button-Help button-Quit
  WITH FRAME brws-frame NO-BOX stream-io.

OPEN QUERY qry FOR EACH ww indexed-reposition.

ON CHOOSE OF button-File
  DO:
  button-File:
  DO:
    APPLY "entry" TO button-File IN FRAME brws-frame.
    STATUS DEFAULT.
    STATUS INPUT
      "Enter full or partial file name. Leave blank for all files".
    IF AVAIL ww THEN
    v-file-name = ww.w_file-name.
    DO ON ERROR  UNDO, LEAVE button-File
        ON ENDKEY UNDO, LEAVE button-File
        ON STOP   UNDO, LEAVE button-File
        ON QUIT   UNDO, LEAVE button-File:
      MESSAGE "Enter File-name" UPDATE v-file-name.
    END.
    /* allow blank to reopen query, strip wildcard */
    IF v-file-name = "*" THEN
    v-file-name = "".
    IF LENGTH(v-file-name) > 1 THEN
    IF SUBSTRING(v-file-name,LENGTH(v-file-name),1) = "*" THEN
    v-file-name = SUBSTRING(v-file-name,1,LENGTH(v-file-name) - 1).
    if v-file-name begins "*" 
    or v-file-name begins "."
    then do:
      close query qry.
      open query qry for each ww where ww.w_file-name matches v-file-name
      indexed-reposition.
    end.
    else do:
    FIND FIRST ww WHERE ww.w_file-name = v-file-name NO-ERROR.
    IF AVAIL ww THEN
    DO:
      CLOSE QUERY qry.
      OPEN QUERY qry FOR EACH ww WHERE ww.w_file-name = v-file-name 
      INDEXED-REPOSITION.
    END.
    ELSE
    DO:
      FIND FIRST ww WHERE ww.w_file-name BEGINS v-file-name NO-ERROR.
      IF AVAIL ww THEN
      DO:
        CLOSE QUERY qry.
        OPEN QUERY qry FOR EACH ww WHERE ww.w_file-name BEGINS v-file-name
        INDEXED-REPOSITION.
      END.
    END.
    end.
  END.
  STATUS DEFAULT m$.
END.

ON CHOOSE OF button-Jump
  DO:
  button-Jump:
  DO:
    APPLY "entry" TO button-Jump IN FRAME brws-frame.
    STATUS DEFAULT.
    STATUS INPUT
      "Enter full or partial file name.".
    DO ON ERROR  UNDO, LEAVE button-Jump
        ON ENDKEY UNDO, LEAVE button-Jump
        ON STOP   UNDO, LEAVE button-Jump
        ON QUIT   UNDO, LEAVE button-Jump:
      MESSAGE "Enter Jump File-name" UPDATE v-jump-name.
    END.
    IF v-jump-name = "*" THEN
    v-jump-name = "".
    IF LENGTH(v-jump-name) > 1 THEN
    IF SUBSTRING(v-jump-name,LENGTH(v-jump-name),1) = "*" THEN
    v-jump-name = SUBSTRING(v-jump-name,1,LENGTH(v-jump-name) - 1).
    IF v-file-name <> "" THEN
    DO:
      /* reopen for all records */
      v-file-name = "".
      HIDE MESSAGE NO-PAUSE.
      MESSAGE "Repositioning Browse ..".
      CLOSE QUERY qry.
      OPEN QUERY qry FOR EACH ww INDEXED-REPOSITION.
      HIDE MESSAGE NO-PAUSE.
      MESSAGE "Repositioning Browse ...".
    END.
    IF v-jump-name <> "" THEN
    DO:
      FIND FIRST ww WHERE ww.w_file-name = v-jump-name NO-ERROR.
      IF NOT AVAIL ww THEN
      FIND FIRST ww WHERE ww.w_file-name BEGINS v-jump-name NO-ERROR.
      IF NOT AVAIL ww THEN
      FIND NEXT ww.
      HIDE MESSAGE NO-PAUSE.
      MESSAGE "Repositioning Browse ....".
      IF AVAIL ww THEN
      REPOSITION qry TO RECID RECID(ww).
    END.
  END.
  HIDE MESSAGE NO-PAUSE.
  STATUS DEFAULT m$.
END.

ON CHOOSE OF button-Order
  DO:
  button-Order:
  DO:
    HIDE MESSAGE NO-PAUSE.
    MESSAGE (IF order-order THEN "Alpha Order" ELSE "Order Number").
    APPLY "entry" TO button-Order.
    IF v-file-name = "" THEN
    DO:
      IF AVAIL ww THEN
      v-file-name = ww.w_file-name.
      ELSE
      LEAVE button-Order.
    END.
    ELSE
    DO:
      FIND FIRST ww WHERE ww.w_file-name = v-file-name NO-ERROR.
      IF NOT AVAIL ww THEN
      FIND FIRST ww WHERE ww.w_file-name BEGINS v-file-name NO-ERROR.
      IF AVAIL ww THEN
      v-file-name = ww.w_file-name.
      ELSE
      LEAVE button-Order.
    END.

    order-order = NOT order-order.
    CLOSE QUERY qry.
    IF NOT order-order THEN
    OPEN QUERY qry FOR EACH ww WHERE ww.w_file-name = v-file-name
      USE-INDEX idx1 INDEXED-REPOSITION.
    ELSE
    OPEN QUERY qry FOR EACH ww WHERE ww.w_file-name = v-file-name
      USE-INDEX idx2 INDEXED-REPOSITION.
  END.
  HIDE MESSAGE NO-PAUSE.
END.

ON CHOOSE OF button-Type
  DO:
  button-Type:
  DO:
    STATUS DEFAULT.
    STATUS INPUT "Enter the type of fields to display.".
    APPLY "entry" TO button-Type.

    do-block:
    DO WHILE TRUE ON ERROR  UNDO, LEAVE button-Type
        ON ENDKEY UNDO, LEAVE button-Type
        ON STOP   UNDO, LEAVE button-Type
        ON QUIT   UNDO, LEAVE button-Type:
      HIDE MESSAGE NO-PAUSE.

      MESSAGE "Enter date type: Dec,Int,Char,Log,daTe" UPDATE v-type.
      IF NOT CAN-DO("D,I,C,L,T",v-type) THEN
      NEXT  do-block.
      ELSE
      LEAVE do-block.
      BELL.
    END.
    IF AVAIL ww THEN
    v-file-name = ww.w_file-name.
    CLOSE QUERY qry.
    OPEN  QUERY qry FOR EACH ww WHERE ww.w_file-name = v-file-name
      AND ww.w_info BEGINS
      ENTRY(LOOKUP(v-type,"D,I,C,L,T"),"dec,int,char,log,date").
  END.
  STATUS DEFAULT m$.
END.

ON CHOOSE OF button-Index
  DO:
  button-Index:
  DO:
    STATUS DEFAULT "Getting Index information...".
    APPLY "entry" TO button-Index.
    IF NOT CONNECTED(ww.w_db-name)
      THEN
    DO ON ERROR UNDO, LEAVE button-Index
        ON ENDKEY UNDO, LEAVE button-Index
        ON STOP UNDO, LEAVE button-Index
        ON QUIT UNDO, LEAVE button-Index:
      HIDE MESSAGE NO-PAUSE.
      MESSAGE "Cannot process request.  Not connected to"
        ww.w_db-name "database. ".
      PAUSE.
      LEAVE button-Index.
    END.
    DO ON ERROR UNDO, LEAVE
        ON ENDKEY UNDO, LEAVE
        ON STOP UNDO, LEAVE
        ON QUIT UNDO, LEAVE:
      HIDE MESSAGE NO-PAUSE.
      CREATE ALIAS xx FOR DATABASE VALUE(ww.w_db-name).
      RUN qd4.p (INPUT ww.w_file-name) NO-ERROR.
      DELETE ALIAS xx.
    END.
  END.
  STATUS DEFAULT m$.
END.

ON CHOOSE OF button-Zoom
DO:
  /* ZOOM */
  button-Zoom:
  DO on endkey undo, leave
     on error  undo, leave
     on stop   undo, leave
     on quit   undo, leave:
    STATUS DEFAULT "Getting Database, File Description, etc....".
    APPLY "entry" TO button-Zoom.
    IF NOT CONNECTED(ww.w_db-name)
      THEN
    DO ON ERROR UNDO, LEAVE button-Zoom
        ON ENDKEY UNDO, LEAVE button-Zoom
        ON STOP UNDO, LEAVE button-Zoom
        on quit undo, leave button-Zoom:
      HIDE MESSAGE NO-PAUSE.
      MESSAGE "Cannot process request.  Not connected to"
        ww.w_db-name "database. ".
      PAUSE.
      LEAVE button-Zoom.
    END.
    DO ON ERROR UNDO, LEAVE
        ON ENDKEY UNDO, LEAVE
        ON STOP UNDO, LEAVE
        ON QUIT UNDO, LEAVE:
      CREATE ALIAS xx FOR DATABASE VALUE(ww.w_db-name).
      RUN qd2.p (INPUT ww.w_file-name, INPUT ww.w_field-name) NO-ERROR.
    END.
  END.
  STATUS DEFAULT m$.
END.

ON CHOOSE OF button-Next
  DO:
  button-Next:
  DO:
    STATUS DEFAULT "Next File...".
    APPLY "entry" TO button-Next.
    IF NOT AVAIL ww THEN
    GET NEXT qry.
    IF v-file-name <> "" THEN
    DO:
      FIND NEXT ww WHERE ww.w_file-name > v-file-name NO-ERROR.
      IF AVAIL ww THEN
      DO:
        v-file-name = ww.w_file-name.
        CLOSE QUERY qry.
        OPEN QUERY qry FOR EACH ww WHERE ww.w_file-name = v-file-name
          INDEXED-REPOSITION.
        LEAVE button-Next.
      END.
      ELSE
      LEAVE button-Next.
    END.
    v-jump-name = ww.w_file-name.
    FIND NEXT ww WHERE ww.w_file-name > v-jump-name NO-ERROR.
    IF NOT AVAIL ww THEN
    DO:
      FIND LAST ww.
      BELL.
      PAUSE 0.
    END.
    IF NOT AVAIL ww THEN
    LEAVE button-Next.
    REPOSITION qry TO RECID RECID(ww) NO-ERROR.
    GET PREV qry.
    GET NEXT qry.
  END.
  STATUS DEFAULT m$.
  RETURN NO-APPLY.
END.

ON CHOOSE OF button-Prev
  DO:
  button-Prev:
  DO:
    STATUS DEFAULT "Previous File...".
    APPLY "entry" TO button-Prev.
    IF NOT AVAIL ww THEN
    GET PREV qry.
    IF v-file-name <> "" THEN
    DO:
      FIND PREV ww WHERE ww.w_file-name < v-file-name NO-ERROR.
      IF AVAIL ww THEN
      DO:
        v-file-name = ww.w_file-name.
        CLOSE QUERY qry.
        OPEN QUERY qry FOR EACH ww WHERE ww.w_file-name = v-file-name
        INDEXED-REPOSITION.
        LEAVE button-Prev.
      END.
      ELSE
      LEAVE button-Prev.
    END.
    IF AVAIL ww THEN
    v-jump-name = ww.w_file-name.
    ELSE
    DO:
      GET NEXT qry.
      IF NOT AVAIL ww THEN
      GET PREV qry.
      IF AVAIL ww THEN
      v-jump-name = ww.w_file-name.
    END.
    FIND PREV ww WHERE ww.w_file-name < v-jump-name NO-ERROR.
    IF AVAIL ww THEN
    DO:
      v-jump-name = ww.w_file-name.
      FIND FIRST ww WHERE ww.w_file-name = v-jump-name.
    END.
    IF NOT AVAIL ww THEN
    DO:
      FIND FIRST ww.
      BELL.
      PAUSE 0.
      LEAVE button-Prev.
    END.
    REPOSITION qry TO RECID RECID(ww) NO-ERROR.
    GET NEXT qry.
    GET PREV qry.
  END.
  STATUS DEFAULT m$.
END.

ON CHOOSE OF button-ByFld
  DO:
  button-ByFld:
  DO:
    APPLY "entry" TO button-ByFld IN FRAME brws-frame.
    STATUS DEFAULT.
    STATUS INPUT
      "Enter full or partial Field. Leave blank for all Fields".
    IF AVAIL ww THEN
    v-field-name = ww.w_field-name.
    DO ON ERROR  UNDO, LEAVE button-ByFld
        ON ENDKEY UNDO, LEAVE button-ByFld
        ON STOP   UNDO, LEAVE button-ByFld
        ON QUIT   UNDO, LEAVE button-ByFld:
      MESSAGE "Enter Field-name" UPDATE v-field-name.
    END.
    /* allow blank to reopen query, strip wildcard */
    IF v-field-name = "*" THEN
    v-field-name = "".
    IF LENGTH(v-field-name) > 1 THEN
    IF SUBSTRING(v-field-name,LENGTH(v-field-name),1) = "*" THEN
    v-field-name = SUBSTRING(v-field-name,1,LENGTH(v-field-name) - 1).
    FIND FIRST ww WHERE ww.w_field-name = v-field-name NO-ERROR.
    IF AVAIL ww THEN
    DO:
      CLOSE QUERY qry.
      OPEN QUERY qry FOR EACH ww WHERE ww.w_field-name = v-field-name 
      INDEXED-REPOSITION.
    END.
    ELSE
    DO:
      FIND FIRST ww WHERE ww.w_field-name BEGINS v-field-name NO-ERROR.
      IF AVAIL ww THEN
      DO:
        CLOSE QUERY qry.
        OPEN QUERY qry FOR EACH ww WHERE ww.w_field-name BEGINS v-field-name.
      END.
    END.
  END.
  STATUS DEFAULT m$.
END.

ON CHOOSE OF button-Help
  DO:
  APPLY "entry" TO button-Help.
  RUN show-help.ip IN THIS-PROCEDURE.
END.

ON CHOOSE OF button-Quit
  DO:
  APPLY "entry" TO button-Quit.
  HIDE ALL NO-PAUSE.
  MESSAGE "Quiting...".
  CLOSE QUERY qry.
  DISABLE ALL WITH FRAME brws-frame.
  APPLY "window-close" TO CURRENT-WINDOW.
END.

ON cursor-up, cursor-down, page-up, page-down, home, END
  OF button-File, button-Jump, button-Order, button-Type, button-Index,
  button-Zoom, button-Next, button-Prev,  button-Help, button-Quit,
  button-ByFld
  IN FRAME brws-frame
  DO:
    apply lastkey to brws in frame brws-frame.
  /***
  IF CAN-DO("CUR*,HOME",STRING(KEYLABEL(LASTKEY)) )
    OR CAN-DO("HOME,END",STRING(KEYFUNCTION(LASTKEY)))
    THEN                                   /* UP/DOWN ARROW PROCESS NORMALLY */
  APPLY LASTKEY TO brws IN FRAME brws-frame.
  ELSE                                     /* PAGE-UP/DOWN NEED SPECIAL HELP */
  IF KEYLABEL(LASTKEY) = "NEXT-SCRN"
    OR KEYFUNCTION(LASTKEY) = "PAGE-DOWN"
    THEN
  REPOSITION qry FORWARD BROWSE brws:down - 1.
  ELSE
  IF KEYLABEL(LASTKEY) = "PREV-SCRN"
    OR KEYFUNCTION(LASTKEY) = "PAGE-UP"
    THEN
  REPOSITION qry BACKWARD BROWSE brws:down + 1.
  ELSE
  IF KEYLABEL(LASTKEY) = "END" THEN
  DO:
    IF v-file-name <> ""
      THEN
    APPLY LASTKEY TO brws IN FRAME brws-frame.
    ELSE
    DO ON ENDKEY UNDO, LEAVE
        ON ERROR  UNDO, LEAVE
        ON STOP   UNDO, LEAVE:
      HIDE MESSAGE NO-PAUSE.
      ans = NO.
      MESSAGE "Do you really want to go the END" UPDATE ans.
      HIDE MESSAGE NO-PAUSE.
      IF ans THEN
      DO ON STOP UNDO, LEAVE:
        MESSAGE "Repositioning to END...".
        APPLY KEYCODE("END") TO brws IN FRAME brws-frame.
        FIND LAST ww NO-ERROR.
        IF AVAIL ww THEN
        v-jump-name = ww.w_file-name.
        PAUSE 0.
      END.
    END.
  END.
  ELSE
  IF CAN-DO("GO,F1,PF1",KEYLABEL(LASTKEY)) THEN
  APPLY "choose" TO SELF.
  ******/
  HIDE MESSAGE NO-PAUSE.
  RETURN NO-APPLY.
END.

on go, f1, pf1 of 
  button-File, button-Jump, button-Order, button-Type, button-Index,
  button-Zoom, button-Next, button-Help, button-Prev, button-ByFld
  IN FRAME brws-frame
  DO:
    apply "choose" to self.
end.

ON f,j,o,t,i,z,n,p,q,h,b,F,J,O,T,I,Z,N,P,Q,H,B OF brws,
  button-File, button-Jump, button-Order, button-Type, button-Index,
  button-Zoom, button-Next, button-Help, button-Prev, button-ByFld
  IN FRAME brws-frame
  DO:
  CASE KEYLABEL(LASTKEY):
    WHEN "F" THEN
    APPLY "choose" TO button-File  IN FRAME brws-frame.
    WHEN "J" THEN
    APPLY "choose" TO button-Jump  IN FRAME brws-frame.
    WHEN "O" THEN
    APPLY "choose" TO button-Order IN FRAME brws-frame.
    WHEN "T" THEN
    APPLY "choose" TO button-Type  IN FRAME brws-frame.
    WHEN "I" THEN
    APPLY "choose" TO button-Index IN FRAME brws-frame.
    WHEN "Z" THEN
    APPLY "choose" TO button-Zoom  IN FRAME brws-frame.
    WHEN "N" THEN
    APPLY "choose" TO button-Next  IN FRAME brws-frame.
    WHEN "P" THEN
    APPLY "choose" TO button-Prev  IN FRAME brws-frame.
    WHEN "Q" THEN
    APPLY "choose" TO button-Quit  IN FRAME brws-frame.
    WHEN "H" THEN
    APPLY "choose" TO button-Help  IN FRAME brws-frame.
    WHEN "B" THEN
    APPLY "choose" TO button-byFld IN FRAME brws-frame.
  END
    CASE.
  RETURN NO-APPLY.
END.

STATUS DEFAULT "".
STATUS DEFAULT .
STATUS INPUT "" .
STATUS INPUT OFF.

ENABLE brws button-File button-Jump button-Order button-Type
  button-Index button-Zoom button-Next button-Prev
  button-ByFld button-Help button-Quit 
  WITH FRAME brws-frame.

STATUS DEFAULT m$.

DEF VAR dummy AS LOGICAL NO-UNDO.
ASSIGN dummy = BROWSE brws:select-focused-row() no-error.

APPLY "entry" TO button-File IN FRAME brws-frame.

WAIT-FOR window-close OF CURRENT-WINDOW
  OR CLOSE OF THIS-PROCEDURE.

CLOSE QUERY qry.
CLEAR FRAME brws-frame.
HIDE FRAME brws-frame NO-PAUSE.
HIDE ALL NO-PAUSE.
PAUSE 0.
QUIT.


/* INTERNAL PROCEDURES */

PROCEDURE show-help.ip:
  STATUS DEFAULT "Press ENTER to continue...".
  MESSAGE COLOR messages
    SKIP
    " File - Restricts browse to a file or group of files.  CU brings up all"
    "         CU* files.  CUSTOMER brings up the CUSTOMER file only.        "
    SKIP(1)
    "Jump - Jump moves browse to file.  Jump is slower than File.            "
    SKIP(1)
    "Order - Toggles between Alphabetical and natural order of fields.        "
    SKIP(1)
    "Type - Restricts browse to specified datatype within the current file.  "
    SKIP(1)
    "Indexes & Zoom - Show more information about the current file.          "
    SKIP(1)
    "Next & Prev - Skips forwards or backwards to the next file.             "
    SKIP(1)
    "ByFld - All files using that field.    Help - Displays this message.    "       SKIP(1)
    "Quit - Exit this application.    Written by Chad Merrill Brackmann 1997 "       SKIP
    VIEW-AS ALERT-BOX TITLE " Help ".
  PAUSE 0 NO-MESSAGE.
  STATUS DEFAULT m$.
END
PROCEDURE.  /* show-help.ip */


PROCEDURE get-schema.ip:

  REPEAT j = 1 TO NUM-DBS ON ERROR UNDO, NEXT
                          ON STOP UNDO, NEXT
                          ON QUIT UNDO, NEXT:
    IF DBTYPE(j) <> "PROGRESS" THEN NEXT.
    CREATE ALIAS xx FOR DATABASE VALUE(LDBNAME(j)).
    RUN qd1.p (INPUT LDBNAME(j)).
  END.

  status default "".
  find first ww no-error.
  if not avail ww then do:
    message color messages skip
            " You are not connected to any databases.  " skip
            " No Schema to show.  Connect at least one " skip
            " database and re-run.                     " skip(1)
            view-as alert-box error title "< Error >".
  end.          

END
PROCEDURE. /* get-schema.ip */

